Connector (Catalina Internal API Documentation)
Keywords: org.apache.catalina.Connector interface

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina
Interface Connector

All Known Implementing Classes:
  HttpConnector, HttpConnector

public interface Connector

A Connector is a component responsible receiving requests from, and returning responses to, a client application. A Connector performs the following general logic:

- Receive a request from the client application.
- Create (or allocate from a pool) appropriate Request and Response instances, and populate their properties based on the contents of the received request, as described below.
  - For all Requests, the `connector`, `protocol`, `remoteAddr`, `response`, `scheme`, `secure`, `serverName`, `serverPort` and `stream` properties MUST be set. The `contentLength` and `contentType` properties are also generally set.
  - For HttpRequests, the `method`, `queryString`, `requestedSessionCookie`, `requestedSessionId`, `requestedSessionURL`, `requestURI`, and `secure` properties MUST be set. In addition, the various `addXxx` methods must be called to record the presence of cookies, headers, and locales in the original request.
  - For all Responses, the `connector`, `request`, and `stream` properties MUST be set.
  - No additional headers must be set by the Connector for HttpResponses.
- Identify an appropriate Container to use for processing this request. For a stand alone Catalina installation, this will probably be a (singleton) Engine implementation. For a Connector attaching Catalina to a web server such as Apache, this step could take advantage of parsing already performed within the web server to identify the Context, and perhaps even the Wrapper, to utilize in satisfying this Request.
- Call the `invoke()` method of the selected Container, passing the initialized Request and Response instances as arguments.
- Return any response created by the Container to the client, or return an appropriate error message if an exception of any type was thrown.
- If utilizing a pool of Request and Response objects, recycle the pair of instances that was just used.

It is expected that the implementation details of various Connectors will vary widely, so the logic above should considered typical rather than normative.

Version:
  $Revision: 289023 $ $Date: 2004-08-26 18:06:34 -0400 (Thu, 26 Aug 2004) $
Author:
  Craig R. McClanahan

Method Summary
`Request` | `createRequest()` Create (or allocate) and return a Request object suitable for specifying the contents of a Request to the responsible Container.
`Response` | `createResponse()` Create (or allocate) and return a Response object suitable for receiving the contents of a Response from the responsible Container.
`Container` | `getContainer()` Return the Container used for processing requests received by this Connector.
`boolean` | `getEnableLookups()` Return the "enable DNS lookups" flag.
`ServerSocketFactory` | `getFactory()` Return the server socket factory used by this Container.
`java.lang.String` | `getInfo()` Return descriptive information about this Connector implementation.
`int` | `getRedirectPort()` Return the port number to which a request should be redirected if it comes in on a non-SSL port and is subject to a security constraint with a transport guarantee that requires SSL.
`java.lang.String` | `getScheme()` Return the scheme that will be assigned to requests received through this connector.
`boolean` | `getSecure()` Return the secure connection flag that will be assigned to requests received through this connector.
`Service` | `getService()` Return the `Service` with which we are associated (if any).
`void` | `initialize()` Invoke a pre-startup initialization.
`void` | `setContainer(Container container)` Set the Container used for processing requests received by this Connector.
`void` | `setEnableLookups(boolean enableLookups)` Set the "enable DNS lookups" flag.
`void` | `setFactory(ServerSocketFactory factory)` Set the server socket factory used by this Container.
`void` | `setRedirectPort(int redirectPort)` Set the redirect port number.
`void` | `setScheme(java.lang.String scheme)` Set the scheme that will be assigned to requests received through this connector.
`void` | `setSecure(boolean secure)` Set the secure connection flag that will be assigned to requests received through this connector.
`void` | `setService(Service service)` Set the `Service` with which we are associated (if any).

Method Detail

### getContainer

    public Container getContainer()

  Return the Container used for processing requests received by this Connector.

### setContainer

    public void setContainer(Container container)

  Set the Container used for processing requests received by this Connector.

  Parameters:
    `container` - The new Container to use

### getEnableLookups

    public boolean getEnableLookups()

  Return the "enable DNS lookups" flag.

### setEnableLookups

    public void setEnableLookups(boolean enableLookups)

  Set the "enable DNS lookups" flag.

  Parameters:
    `enableLookups` - The new "enable DNS lookups" flag value

### getFactory

    public ServerSocketFactory getFactory()

  Return the server socket factory used by this Container.

### setFactory

    public void setFactory(ServerSocketFactory factory)

  Set the server socket factory used by this Container.

  Parameters:
    `factory` - The new server socket factory

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this Connector implementation.

### getRedirectPort

    public int getRedirectPort()

  Return the port number to which a request should be redirected if it comes in on a non-SSL port and is subject to a security constraint with a transport guarantee that requires SSL.

### setRedirectPort

    public void setRedirectPort(int redirectPort)

  Set the redirect port number.

  Parameters:
    `redirectPort` - The redirect port number (non-SSL to SSL)

### getScheme

    public java.lang.String getScheme()

  Return the scheme that will be assigned to requests received through this connector. Default value is "http".

### setScheme

    public void setScheme(java.lang.String scheme)

  Set the scheme that will be assigned to requests received through this connector.

  Parameters:
    `scheme` - The new scheme

### getSecure

    public boolean getSecure()

  Return the secure connection flag that will be assigned to requests received through this connector. Default value is "false".

### setSecure

    public void setSecure(boolean secure)

  Set the secure connection flag that will be assigned to requests received through this connector.

  Parameters:
    `secure` - The new secure connection flag

### getService

    public Service getService()

  Return the `Service` with which we are associated (if any).

### setService

    public void setService(Service service)

  Set the `Service` with which we are associated (if any).

  Parameters:
    `service` - The service that owns this Engine

### createRequest

    public Request createRequest()

  Create (or allocate) and return a Request object suitable for specifying the contents of a Request to the responsible Container.

### createResponse

    public Response createResponse()

  Create (or allocate) and return a Response object suitable for receiving the contents of a Response from the responsible Container.

### initialize

    public void initialize()
                    throws LifecycleException

  Invoke a pre-startup initialization. This is used to allow connectors to bind to restricted ports under Unix operating environments.

  Throws:
    `LifecycleException` - If this server was already initialized.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2002 Apache Software Foundation. All Rights Reserved.